//	$Id: newss_cnews.g,v 1.2 1994/10/22 17:08:32 agl Exp agl $
//	AGL(C) 1994
//
#include "a_shm.i"
#include "mmap.i"
#include "a_stdio.h"
#include <errno.h>
#include <dirent.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/stat.h>
#ifndef NOMMAP
#include <sys/mman.h>
#include <linux/page.h>
#endif
#include <alloca.h>
#include <strings.h>
#include <fcntl.h>
#include <unistd.h>

//	Available only with __KERNEL__ defined. Shit!
//	Are you going to #define __KERNEL__ in a mortal application?
//	check to see if it matches the declarations in page.h first
			/* to mask away the intra-page address bits */
#define PAGE_MASK			(~(PAGE_SIZE-1))
			/* to align the pointer to the (next) page boundary */
#define PAGE_ALIGN(addr)		(((addr)+PAGE_SIZE-1)&PAGE_MASK)
class	DirEntry {
public:
	char	name[9]; // Have you seen a group with more then 1GB articles?
	size_t	len,rlen;
	DirEntry	*next;
};
int	debug=0;
int	mapd(SHMID &agl, char *name, int perms) { char cwd[1024];
	if(getcwd(cwd,sizeof cwd)==NULL || chdir(name)) {
cantcd:		a_fatal(grc.get(10,0),1027);
	} 
	DIR *dd=opendir(name); DirEntry *cdir=0,*_,**ct=&cdir;
	if(dd==0)	return 1;
	struct dirent *_e;
	for(;_e=readdir(dd);) {
		if(!isdigit(_e->d_name[0])) continue;
		stat buf;
		if(stat(_e->d_name,&buf)) {
			// Can't stat
			a_fatal(grc.get(1,4),1031);
			continue;
		}	
		if((_=(DirEntry*)alloca(sizeof(DirEntry)))==0) {
			a_fatal(grc.get(10,1),1028);
		}
		*ct=_; ct=&_->next; _->next=0; // FIFO
		//_->next=cdir; cdir=_; // LIFO
		strncpy(_->name, _e->d_name, sizeof name);
		agl.coreused+=_->len=PAGE_ALIGN(_->rlen=buf.st_size);
	}
	closedir(dd); agl.coresize=agl.coreused*2;
	if((agl.shmid=shmget(IPC_PRIVATE,agl.coresize,0622))==-1)
	{
		a_fatal(grc.get(10,2),1029);
	}
	shmid_ds shmid_ds;
		shmid_ds.shm_perm.gid=0; // For restricted newsgroups
				// set the GID to the actual newsgroup
	shmctl(agl.shmid,IPC_SET,&shmid_ds); caddr_t	mappedto,tt;
	if( (tt=mappedto=shmat (agl.shmid,0,0))==(char*)-1) {
		a_fatal(grc.get(10,3),1029);
	}
	for(_=cdir;_;_=_->next) {
#ifdef NOMMAP
		FILE *ffd;
		if((ffd=fopen(name,"r"))==0) {
			a_print(grc.get(2,2));	return 1;
		}
//		if((mappedto=new char[_->len])==0) a_fatal(grc.get(10,6),1034);
		if(fread(mappedto,_->rlen,1,ffd)<1)
			a_fatal(grc.get(10,5),1033);
		mappedto+=_->rlen;
		fclose(ffd);
#else
		int fd; if((fd=open(_->name,O_RDONLY))==-1) {
			a_fatal(grc.get(10,4),1032);
		}
		mappedto=
		mmap(mappedto,_->rlen,PROT_READ,MAP_FIXED|MAP_SHARED,fd,0);
		close(fd); // Would it ever fail on O_RDONLY?
		if((int)mappedto==-1) { printf("ERRNO %d\n",errno);
			a_fatal(grc.get(1,3),1030);
		}
		mappedto+=_->len;
#endif
	}
	// Build up the directory of mapped articles (in the offset/size form)
	NArt *dir=(NArt *)mappedto; size_t cofft=0; agl.dirofft=agl.coreused;
	for(_=cdir;_;_=_->next,++dir,++agl.nels) {
		fwrite(tt+cofft,1,_->rlen,stderr);
		dir->offt=cofft; cofft+=_->len;
		dir->size=_->rlen;
	}					agl.coreused+=cofft;
	if(chdir(cwd)) goto cantcd;
	return	0;
}
size_t	matchdepth( char *_1, size_t matchlen[] )
{
	size_t matchdepth=0,_=0,_t_=0;
	for(;*_1!='\0';) {
		++_; if(*_1++=='.') { matchlen[matchdepth++]=_t_+=_; _=0; }
	}
	matchlen[matchdepth]=_t_+_; return matchdepth;
}
/* _1 previous _2 current */
size_t	matchdepth( char *_1, char *_2, size_t &match, size_t matchlen[] )
{
	size_t depth=0,_=0,_t_=0,__=strlen(_1);
#define _MATCH { ++_;if(*_2++=='.') { matchlen[depth++]=_t_+=_; _=0; } }
	if(_1) for(;*_1++==*_2;)	_MATCH
	for(match=depth;*_2!='\0';)	_MATCH
	matchlen[depth]=__; return depth;
}
int
NewsS::initss()
{
	char *newsg,*newde,*newhi;
	size_t	nssize, // total spacesize
		nssz, ndsz, nhsz, // source sizes
		ngrpn, nnlea;
	AMemMap	a,b,c;
			// Reading grouplist from ~news/active
#define	FILEINFOFAIL(FILENAME) { \
		fprintf(stderr,"Can't map %s. Exiting\n",FILENAME); exit(-1); }
	if(a.a_fileinfo(NEWSACTIVE, newsg, ngrps, nssz))
		FILEINFOFAIL(NEWSACTIVE)
			// and descriptions from ~news/newsgroups
	if(b.a_fileinfo(NEWSGROUPS, newde, ngrpn, ndsz))
		FILEINFOFAIL(NEWSGROUPS);
			// non-leaf hierarchy
	if(c.a_fileinfo(NEWSHIERAR, newhi, nnlea, nhsz))
		FILEINFOFAIL(NEWSHIERAR);
	nssize=nssz+ndsz+ndsz;
	//	make sure we get enough for non-leaves too
	const	grpsinfosize=sizeof(NGrpInfo) * (ngrps+nnlea);
	size = grpsinfosize + nssize;
	if((shmid=shmget(IPC_PRIVATE,PAGE_ALIGN(size),0622))==-1)
	{
		a_fatal(grc.get(10,2),1029);
	}
	NGrpInfo	*grps, *desc;
	char		*space, *cspace, *j; size_t o;
	desc=grps=(NGrpInfo*)space=cspace=(char*) shmat (shmid,0,0);
	if( space==(char*)-1) a_fatal(grc.get(10,3),1029);
	space+=o=grpsinfosize;
#define FILLSPACE(ch) { if(nssize-- <= 0) a_fatal(grc.get(10,7),1035); \
						o++; *space++=ch; }
#define SUBSPACE(sub) { if((nssize-=sub) <= 0) a_fatal(grc.get(10,7),1035); \
						o+=sub; space+=sub; }
#define	SCANNAME(vsize,outlabel) \
		for(grps->name=o, grps->desc=0;;) { \
			if(isspace(*j)) break; \
			if(vsize-- <= 0) { FILLSPACE('\0') goto outlabel; } \
			FILLSPACE(*j++) \
		}	FILLSPACE('\0') // Terminate newsgroup name
		//	Now skip spaces and add desc if any
#define	NEXTJ(vsize,outlabel)	if(vsize-- <= 0) goto outlabel; ++j;
#define ADDDESC(vsize,optcond,uniqlbl,outlabel) \
		for(;;){if(*j == '\n') { \
				uniqlbl: NEXTJ(vsize,outlabel) break; } \
			if(optcond !isspace(*j)) { grps->desc=o; do \
				{	if(*j=='?') { grps->desc=0; \
					while(*j++ != '\n'); goto uniqlbl; } \
				if(vsize-- <= 0) { FILLSPACE('\0') goto outlabel; } \
					FILLSPACE(*j++) \
				}	while(*j != '\n'); FILLSPACE('\0') \
				goto uniqlbl; \
			} \
			NEXTJ(vsize,outlabel) \
		}
	// Now read in the USENET newsgroups tree from 'active'
	// active should be sorted !!!
	for(j=newsg;;++grps) {
		SCANNAME(nssz,outof1)
		fprintf(stdout, "active: %s\n", cspace+grps->name);
		for(;;) {
			if(nssz-- <= 0) goto outof1;
			if(*j++ == '\n') break;
		}
	}
outof1:	// Bits of by-hand optimization to make gcc's life easier ;-)
	// and the code more readable %^]
#define spc newsg
	grps=desc; nnlea=ngrps;
	for(j=newde;nnlea>0;++grps,--nnlea) { // Search for description
		uint sz;
repeat:		spc=j;
		for(sz=0;;++sz) {
			if(isspace(*j++)) break;
			if(ndsz-- <= 0) goto outof2;
		}
repcmp:		int	ttt=strncmp(spc,cspace+grps->name,sz);
			 // No description for the group
		if(ttt>0) {
			if(debug > 5)
			fprintf(stderr,"warning: %s has no description!\n",
				cspace+grps->name);
			++grps; if(--nnlea>0) goto repcmp;
			goto outof2;
		}
		else if(debug > 5 && ttt<0) { _less:
			fprintf(stderr,"warning: "); anprint(spc,sz,stderr);
			fprintf(stderr," is not in active\n");
		}else
		if(strlen(cspace+grps->name) > sz) goto _less;
		// Ok found a match
		ADDDESC(ndsz, ttt==0 &&,njb1,outof2)
		if(ttt<0) goto repeat;
	}
outof2:	// For now, we had to build up the hierarchy for the browsing
	// purposes
	fprintf(stdout,"Now building the tree...\n"); fflush(stdout);
	NGrpInfo *hie[128],*cur; size_t ii,s,match,matchlen[128];
	for(ii=0;ii<128;++ii) hie[ii]=0;
	// Build up a node even if it has only one child. We can postprocess
	// but leaving it up to a client since we must deal with descriptions
	// either. Comprehend?
	for(ii=0,cur=desc;ii<ngrps;++ii,++cur) {
		printf("Looping #1: %s %s\n",cspace+cur->name,cspace+cur->desc);
	}
	int depth=0; char *prev=0; hier_s=o;
	for(ii=0,cur=desc;ii<ngrps;++ii,++cur) {
		depth=matchdepth( prev, cspace+cur->name, match, matchlen);
printf("Looping2: %s \tmatch:%d depth:%d\n",cspace+cur->name,(int)match,(int)depth);
		for(s=match;s<depth;++s) {
			if(s>0) hie[s-1]->nlev=o;
			if(hie[s]) hie[s]->next=o;
			(hie[s]=desc+o)->init(); SUBSPACE(sizeof(NGrpInfo))
			hie[s]->name=o;
			for(size_t t=0;t<matchlen[s];++t)
				FILLSPACE(cspace[cur->name+t]) FILLSPACE('\0')
printf("Node: %s\n",cspace+hie[s]->name); fflush(stdout);
		} // Now for the leaf itself
		if(hie[depth]) {
			hie[depth]->next=ii;
		}	hie[depth]=cur;
		if(prev){if(hie[match]==0) { fprintf(stderr,"Panic!9999"); exit(-1); }
			hie[match]->nlev=ii;
		}
		prev=cspace+cur->name;
	}
	//	Merging in _secondary_ descriptions
	//	the reason is simple: we can use newsgroups generated elsewhere
	//	_but_ we might need a secondary with permissions in place
	//	_and_ newsgroup hierarchy description[s]
	fprintf(stdout,"Well, now read in the newshier...\n"); fflush(stdout);
/*	for(j=newhi;;++grps) { // Exit only on exhausted source
		SCANNAME(nhsz,outof0)
		ADDDESC( nhsz,,njb2,outof0)
	}*/
outof4:;
	for(cur=(NGrpInfo*)cspace+hier_s;;)
	{
		cur=cur->child(cspace);
		cur=cur->_next(cspace);
	}
}/*initss()*/

//	EOF  $Id: newss_cnews.g,v 1.2 1994/10/22 17:08:32 agl Exp agl $
